unit d_DM0;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Modules, XData.Web.Connection,
  App.Types, WEBLib.Dialogs, XData.Web.Dataset, DateUtils, DB, WebLib.JSON, JS,
  System.Variants, XData.Web.JsonDataset, XData.Web.Client, Vcl.Controls, WEBLib.Forms;

type
  TaStrings = Array Of String;
  TDataOperState = (doNone, doInsert, doInsertAuto, doEdit, doBrowse, doDelete);

  TDM0 = class(TWebDataModule)
    conDB: TXDataWebConnection;
    conDG: TXDataWebConnection;
    authDG: TXDataWebConnection;
    wdTOrd: TXDataWebDataSet;
    wsTOrd: TWebDataSource;
    wdROrd: TXDataWebDataSet;
    wsROrd: TWebDataSource;
    wdTOrdPK_1: TIntegerField;
    wdTOrdCAUSALE: TStringField;
    wdTOrdTIPO_DOC: TStringField;
    wdTOrdDATA_DOC: TDateTimeField;
    wdTOrdNUM_DOC: TStringField;
    wdTOrdCOD_PC: TStringField;
    wdTOrdCOD_OPER: TStringField;
    wdTOrdTIPO_SOGG: TStringField;
    wdTOrdCOD_CLIFOR: TStringField;
    wdTOrdCOD_CLI_GFE: TStringField;
    wdTOrdRAG_SOC_1: TStringField;
    wdTOrdRAG_SOC_2: TStringField;
    wdTOrdINDIRIZZO: TStringField;
    wdTOrdCITTA: TStringField;
    wdTOrdPROV: TStringField;
    wdTOrdCAP: TStringField;
    wdTOrdTELEF_1: TStringField;
    wdTOrdTELEF_2: TStringField;
    wdTOrdEMAIL: TStringField;
    wdTOrdTOT_ESENTE_IVA: TFloatField;
    wdTOrdTOT_IMPONIBILE: TFloatField;
    wdTOrdTOT_IVA: TFloatField;
    wdTOrdTOT_OMAGGI: TFloatField;
    wdTOrdTOT_EXTRA: TFloatField;
    wdTOrdTOT_DOC: TFloatField;
    wdTOrdTOT_RICEVUTO: TFloatField;
    wdTOrdTOT_INCASSATO: TFloatField;
    wdTOrdTOT_RESTO: TFloatField;
    wdTOrdSTATO_DOC: TIntegerField;
    wdTOrdDATA_ORA_ASP: TDateTimeField;
    wdTOrdNOTE_ASP: TStringField;
    wdTOrdCMD_PK1: TIntegerField;
    wdROrdPK_1: TXDataWebEntityField;
    wdROrdPK_2: TIntegerField;
    wdROrdPOS_RIGO: TIntegerField;
    wdROrdTIPO_RIGO: TStringField;
    wdROrdART_PK1: TIntegerField;
    wdROrdDATICONT_PK2: TIntegerField;
    wdROrdTIPO_ART: TStringField;
    wdROrdDESC_ART: TStringField;
    wdROrdDESC_BREVE: TStringField;
    wdROrdCOD_SET: TStringField;
    wdROrdCOD_GRP: TStringField;
    wdROrdCOD_UM: TStringField;
    wdROrdPZ_PER_CF: TIntegerField;
    wdROrdQUANTITA: TFloatField;
    wdROrdPREZZO: TFloatField;
    wdROrdTOT_IMPORTO: TFloatField;
    wdROrdTOT_IMP_NET: TFloatField;
    wdROrdTOT_IVA: TFloatField;
    wdROrdTOT_RIGO: TFloatField;
    wdTOrdINIZIO_INS: TDateTimeField;
    wdTOrdFINE_INS: TDateTimeField;
    wdTOrdINIZIO_ESEC: TDateTimeField;
    wdTOrdFINE_ESEC: TDateTimeField;
    wdcData: TXDataWebClient;
    wdTOrdORD_RISTO_R: TXDataWebDatasetField;
    wdROrdVEND_A_FRAZ: TBooleanField;
    wdROrdVALUTA_QTA_VAR: TBooleanField;
    wdROrdAPPLICA_RID_VAR: TBooleanField;
    wdROrdMEZZA_PORZ: TBooleanField;
    wdROrdPREZZO_IVATO: TBooleanField;
    wdTOrdVEN_POS: TBooleanField;
    procedure conDBError(Error: TXDataWebConnectionError);
    procedure conDBRequest(Args: TXDataWebConnectionRequest);
    procedure conDBResponse(Args: TXDataWebConnectionResponse);
    procedure WebDataModuleCreate(Sender: TObject);
    procedure wdOrdAfterApplyUpdates(Sender: TDataSet; Info: TResolveResults);
    procedure wdTOrdNewRecord(DataSet: TDataSet);
    procedure wdROrdNewRecord(DataSet: TDataSet);
    [ASYNC] procedure wdROrdAfterOpen(DataSet: TDataSet);
    procedure WebDataModuleDestroy(Sender: TObject);
    procedure wdROrdBeforePost(DataSet: TDataSet);
    procedure wdROrdAfterPost(DataSet: TDataSet);
    procedure wdROrdAfterDelete(DataSet: TDataSet);
    procedure wdTOrdAfterOpen(DataSet: TDataSet);
  private
    FUnauthorizedAccessProc: TUnauthorizedAccessProc;
    OrdPK2:Integer;
    orOper:Word;
    CodUtente:String;
  public
    procedure InitApp(SuccessProc: TSuccessProc; UnauthorizedAccessProc: TUnauthorizedAccessProc);
    Procedure CreaModOrdine(pCodUtente:String);
    //Function Calc_RiepOrdine():TJSPromise;
    Procedure Calc_RiepOrdine();
    Function SalvaAnnulla_Ordine(Azione:Word):TJSPromise;
  end;

Const
  //AUTH_URL = 'http://ntgest.it:80/DB_NT/Auth';
  //DATA_URL = 'http://ntgest.it:80/DB_NT';
  // Url per LAN interna
  //AUTH_URL = 'http://10.10.10.100:80/DB_NT/Auth';
  //DATA_URL = 'http://10.10.10.100:80/DB_NT';
  AUTH_URL_DG = 'http://localhost:8084/DG/Auth';
  DATA_URL_DG = 'http://localhost:8084/DG';

  DATA_URL_DB = 'http://localhost:8084/DB_1';

  {
  AUTH_URL_DG = 'http://ristord.ddns.net:80/DG/Auth';
  DATA_URL_DG = 'http://ristord.ddns.net:80/DG';

  DATA_URL_DB = 'http://ristord.ddns.net:80/DB_1';
  }

  orNEW = 1;
  orMOD = 2;

  saSALVA = 1;
  saINOLTRA = 2;
  saPARCH = 3;
  saELIM = 4;

Var
  DM0: TDM0;


Function GetJsonValues(JsonString:String; FldNames:TaStrings; xData:TXDataWebDataSet = Nil):TaStrings;


implementation

uses Web, XData.Web.Request, XData.Web.Response, Auth_Service, Main, MainUnit, RiepOrd,
  MenuOrd;

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TDM0.WebDataModuleCreate(Sender: TObject);
begin
  // ATTENZIONE :
  // 1) implementare la procedura di acquisizione dei campi AUTH_URL, DATA_URL
  // 2) non aprire il DataConnection qua. Viene aperto dopo il login con le opportune
  //    procedure di SuccessOnLogin

  orOper:=0;
  OrdPK2:=0;
end;
// -----------------------------------------------------------------------------
procedure TDM0.InitApp(SuccessProc:TSuccessProc; UnauthorizedAccessProc:TUnauthorizedAccessProc);
begin
  FUnauthorizedAccessProc:=UnauthorizedAccessProc; // dichiarata nel dpr

  authDG.URL:=AUTH_URL_DG;
  conDG.URL:=DATA_URL_DG;
  conDB.URL:=DATA_URL_DB;

  authDG.Open(SuccessProc);

  conDB.Open();
end;
// -----------------------------------------------------------------------------
{ Se c' un ordine gi aperto (inizio_ins = pieno e fine_ins = vuoto) lo recupera chiedendo
  all'utente la conferma, se No lo elimina e ne inserisce uno nuovo
  IMPORTANTE : logica di funzionamento
  Il tutto  asincrono ovvero le azioni di Open/Load finiscono con gli eventi AftrOpen e AfterApplyUpd
  dove poi dovr essere gestita la parte di setting dei valori o ingresso forms.
  La sequenza degli eventi  'grossomodo' questa :
     wdTOrdAfterOpen -> wdOrdAfterApplyUpdates | wdROrdAfterOpen
}
Procedure TDM0.CreaModOrdine(pCodUtente:String); // Ritorna il nr. ordine, -1 errore
Var QryOrd:String;
  ResData:TaStrings;

  Procedure PreparaOrd(OrdPK1:Integer = 0);
  Begin
    With wdTOrd Do Begin
      OrdPK2:=0;

      If OrdPK1 = 0 Then Begin  // Nuovo ordine
        orOper:=orNEW;

        Close();
        SetJsonData('{}');
        Open();  // fire : wdTOrdAfterOpen

      End Else Begin // Result > 0 c' un ordine gi aprto
        orOper:=orMOD;

        Close();
        QueryString:=Format('$filter=(PK_1 eq %d)&$expand=ORD_RISTO_R',[OrdPK1]);
        Load();  // fire : wdTOrdAfterOpen
      End;
    End;
  End;
  // ---------------------------------------------------------
  procedure OnDataResponse(DataResponse: TXDataClientResponse);
  Var OrdPK1:Integer;
    Procedure MsgDlgProc(AValue: TModalResult);
    Begin
      If AValue = mrYes Then Begin  // Apre l'ultimo ordine sospeso del cliente
        // 1) Carica i dati e in wdROrdAfterOpen Apre il riepilogo
        PreparaOrd(OrdPK1);
      End;
      If AValue = mrNo Then Begin
        // 1) Elimina sul server l'ordine sospeso dall'archivio ...
        QryOrd:=Format('DELETE FROM Ord_Risto_T WHERE PK_1 = %d ', [OrdPK1]);
        wdcData.RawInvoke('IDataService.Call_ServiceWeb',['QRY_CMD',QryOrd,-1], Nil);
        // 2) ... ne apre un altro nuovo ...
        PreparaOrd(0);
      End;
    End;
  Begin
    OrdPK1:=0;
    // NB : il nome del campo di ritorno  casesensitive, deve essere maiuscolo
    ResData:=GetJsonValues(String(DataResponse.Result),['PK_1']);
    If Length(ResData) > 0 Then
      OrdPK1:=StrToInt(ResData[0]);

    // Se gi esiste un ordine chiede se lo si vuole riaprire gestendo i casi nella sotto procedura MsgDlgProc,
    // se non esiste ne crea uno nuovo
    If OrdPK1 > 0 Then
      frmMain.WebMessageDlg.ShowDialog(
        'Vuoi riprendere l''ultimo ordine sospeso ?'+#13#10+'(NO crea un nuovo ordine)', mtConfirmation, [mbYes, mbNo], @MsgDlgProc)
    Else Begin
      PreparaOrd(0);
    End;
  End;
Begin
  CodUtente:=pCodUtente;

  // Cerca un ordine gi aperto per l'utente loggato, altrim. lo inserisce nuovo
  QryOrd:=Format(
    'SELECT PK_1 FROM Ord_Risto_T '+
    'WHERE Cod_CliFor = ''%s'' AND Coalesce(Inizio_Ins,'''') <> '''' AND Coalesce(Fine_Ins,'''') = '''' ',
    [CodUtente]);

  wdcData.RawInvoke('IDataService.Call_ServiceWeb',['QRY_SEL',QryOrd,-1], @OnDataResponse);
End;
// -----------------------------------------------------------------------------
procedure TDM0.wdOrdAfterApplyUpdates(Sender: TDataSet; Info: TResolveResults);
Var i:Smallint;
  ResolveInfo:TResolveInfo;
begin
  For I:=0 to Length(Info.Records)-1 Do Begin
    ResolveInfo:=Info.Records[I];
    //If ResolveInfo.Status = TUpdateStatus.usResolveFailed Then Begin
    If ResolveInfo.Error <> '' Then Begin
      frmMain.WebMessageDlg.ShowDialog(ResolveInfo.Error, mtError, [mbOk], Nil);
      Exit;  // al primo errore esce !
    End;
  End;

  If orOper = orNEW Then Begin
    wdROrd.Close();
    wdROrd.SetJsonData(wdTOrdORD_RISTO_R.Value);
    wdROrd.Open();  // fire : wdROrdAfterOpen
  End;
end;
// -----------------------------------------------------------------------------
procedure TDM0.wdTOrdAfterOpen(DataSet: TDataSet);
begin
  If orOper = orNEW Then Begin
    DataSet.Insert();
    DataSet.Post();

    // Nella creazione di un nuovo ordine ApplyUpd serve a committare l'ordine appena creato
    // per ricavare il PK_1 che serve per gli inserimenti di dettaglio in wdROrdNewRecord
    wdTOrd.ApplyUpdates();  // fire : wdOrdAfterApplyUpdates
  End;
  If orOper = orMOD Then Begin
    wdROrd.Close();
    wdROrd.SetJsonData(wdTOrdORD_RISTO_R.Value);
    wdROrd.Open();  // fire : wdROrdAfterOpen
  End;
end;
// -----------------------------------------------------------------------------
procedure TDM0.wdTOrdNewRecord(DataSet: TDataSet);
begin
  DataSet.FieldByName('ORD_RISTO_R').Value:=TJSArray.New();
  DataSet.FieldByName('Cod_CliFor').AsString:=CodUtente;
  DataSet.FieldByName('Inizio_Ins').AsDateTime:=Now();
end;
// -----------------------------------------------------------------------------
procedure TDM0.wdROrdAfterOpen(DataSet: TDataSet);
begin
  // rilevo l'ultimo progressivo rigo per event. inserimenti successivi
  If DataSet.RecordCount > 0 Then Begin
    DataSet.Last();
    OrdPK2:=DataSet.FieldByName('PK_2').AsInteger;
  End;

  // Calc_RiepOrdine();  // <- qua fa casini sui dettagli

  If orOper = orNEW Then Begin
    If Assigned(frmMain.fMenuOrdForm) Then
      FreeAndNil(frmMain.fMenuOrdForm);
    frmMain.fMenuOrdForm:=TfrmMenuOrd.CreateNew(frmMain.pnlMenuOrd.ElementID, Nil);
  End Else If orOper = orMOD Then Begin
    If Assigned(frmMain.fRiepOrdForm) Then
      FreeAndNil(frmMain.fRiepOrdForm);
    frmMain.fRiepOrdForm:=TfrmRiepOrd.CreateNew(frmMain.pnlRiepOrd.ElementID, Nil);
  End;

  orOper:=0; // <- Importante
end;
// -----------------------------------------------------------------------------
procedure TDM0.wdROrdNewRecord(DataSet: TDataSet);
begin
  TJSObject(wdROrd.CurrentData)['PK_1@xdata.ref']:=
    Format('ORD_RISTO_T(%d)', [TJSObject(wdTOrd.CurrentData)['PK_1']]);

  Inc(OrdPK2);
  Dataset.FieldByName('PK_2').AsInteger:=OrdPK2;
end;
// -----------------------------------------------------------------------------
procedure TDM0.wdROrdBeforePost(DataSet: TDataSet);
begin
  With Dataset Do Begin
    FieldByName('Tot_Importo').AsFloat:=
          FieldByName('Quantita').AsFloat * FieldByName('Prezzo').AsFloat;
    FieldByName('Tot_Rigo').AsFloat:=FieldByName('Tot_Importo').AsFloat;
  End;
end;
// -----------------------------------------------------------------------------
procedure TDM0.wdROrdAfterPost(DataSet: TDataSet);
begin
  Calc_RiepOrdine();
end;
// -----------------------------------------------------------------------------
procedure TDM0.wdROrdAfterDelete(DataSet: TDataSet);
begin
  Calc_RiepOrdine();
end;
// -----------------------------------------------------------------------------
Procedure TDM0.Calc_RiepOrdine();
Var TotOrd:Currency;
  SaveRec:TBookmark;
Begin
  Try
    TotOrd:=0;

    wdTOrd.DisableControls();
    wdROrd.DisableControls();

    SaveRec:=wdROrd.GetBookmark();

    TotOrd:=0;
    wdROrd.First();
    While Not wdROrd.Eof Do Begin
      TotOrd:=TotOrd + wdROrd.FieldByName('Tot_Rigo').AsFloat;
      // ATTENZIONE : Non editare wdROrd in quanto scatena di nuovo wdROrdAfterPost
      wdROrd.Next();
    End;

    If Not (wdTOrd.State In [dsEdit,dsInsert])Then
      wdTOrd.Edit();
    wdTOrd.FieldByName('Tot_Doc').AsFloat:=TotOrd;
    //wdTOrd.FieldByName('Cafusale').AsString:='ddd';
    wdTOrd.Post();

  Finally
    wdROrd.GotoBookmark(SaveRec);
    wdROrd.FreeBookmark(SaveRec);
    wdTOrd.EnableControls();
    wdROrd.EnableControls();
  End;
End;
// -----------------------------------------------------------------------------
// saSALVA, saINOLTRA, saPARCH, saELIM
// NB : il TJSPromise va usato con AWait in una procedura/funct dichiarata [ASYNC]
Function TDM0.SalvaAnnulla_Ordine(Azione:Word):TJSPromise;
Var QryOrd:String;
  InfoUpd:TResolveInfoArray;
Begin
  Result:=TJSPromise.New(Procedure(ASuccess, AFailed: TJSPromiseResolver)
  Begin
    Try Try
      If Azione = saINOLTRA Then Begin
        If Not (wdTOrd.State In [dsEdit,dsInsert])Then
          wdTOrd.Edit();
        wdTOrd.FieldByName('Fine_Ins').AsDateTime:=Now();
      End;
      // Il parcheggio in pratica  un ordine sospeso che posso recuperare successivamente
      // e quindi ne azzero la data di fine inserimento
      If Azione = saPARCH Then Begin
        If Not (wdTOrd.State In [dsEdit,dsInsert])Then
          wdTOrd.Edit();
        wdTOrd.FieldByName('Fine_Ins').Clear();
      End;

      If Azione In [saSALVA,saINOLTRA,saPARCH] Then Begin


      {
      If Not (wdTOrd.State In [dsEdit,dsInsert])Then
        wdTOrd.Edit();
      //wdTOrd.FieldByName('Tot_Doc').AsFloat:=TotOrd;
      wdTOrd.FieldByName('Causale').AsString:='ddd';
      }


        If wdTOrd.State In [dsEdit,dsInsert] Then
          wdTOrd.Post();
        If wdROrd.State In [dsEdit,dsInsert] Then
          wdROrd.Post();

        InfoUpd:=wdTOrd.GetPendingUpdates();
        If Length(InfoUpd) > 0 Then
          wdTOrd.ApplyUpdates();

        InfoUpd:=wdROrd.GetPendingUpdates();
        If Length(InfoUpd) > 0 Then
          //frmMain.WebMessageDlg.ShowDialog('rigo salvato !', mtInformation, [mbOk], Nil);
          wdROrd.ApplyUpdates();
        //end;
      End;

      If(Azione = saELIM)AND(wdTOrd.FieldByName('PK_1').AsInteger > 0)Then Begin
        // 1) Elimina sul server l'ordine sospeso dall'archivio ...
        QryOrd:=Format('DELETE FROM Ord_Risto_T WHERE PK_1 = %d ', [wdTOrd.FieldByName('PK_1').AsInteger]);
        wdcData.RawInvoke('IDataService.Call_ServiceWeb',['QRY_CMD',QryOrd,-1], Nil);
      End;

      ASuccess(True);
    Except
      On E:Exception Do Begin
        ASuccess(False);
        Raise E.Create('DM0.SalvaAnnulla_Ordine error : '+E.Message);
      End;
    End;
    Finally
      // fa qualcosa
    End;
  End);  // promise
End;
// -----------------------------------------------------------------------------
procedure TDM0.conDBRequest(Args: TXDataWebConnectionRequest);
begin
  If AuthService.Authenticated Then Begin
    Args.Request.Headers.SetValue('Authorization', 'Bearer ' + AuthService.GetToken);
    // Data_User_Name  trasferito sul server per indicare l'utente che ha fatto l'operazione
    // di INSERT, UPDATE o DELETE sui dati tramite DM0.AureliusModelEventsSQLExecuting
    Args.Request.Headers.SetValue('Data_User_Name', JS.ToString(AuthService.TokenPayload.Properties['Desc_Oper']));
  End;
end;
// -----------------------------------------------------------------------------
procedure TDM0.conDBResponse(Args: TXDataWebConnectionResponse);
begin
  // The 401 Unauthorized Error is an HTTP response status code indicating that the request
  // sent by the client could not be authenticated
  If Args.Response.StatusCode = 401 Then
    FUnauthorizedAccessProc(Format('%d: %s',[Args.Response.StatusCode, Args.Response.ContentAsText]));
end;
// -----------------------------------------------------------------------------
procedure TDM0.conDBError(Error: TXDataWebConnectionError);
begin
  MessageDlg(Error.ErrorMessage+': '+Error.RequestUrl, mtError, []);
end;
// -----------------------------------------------------------------------------
Function GetJsonValues(JsonString:String; FldNames:TaStrings; xData:TXDataWebDataSet = Nil):TaStrings;
Var JsonValues,JsonRecs:TJSONValue;
  JsonMain:TJSONObject;
  I,j:Integer;
  CurrFld:String;
Begin
  Try Try
    SetLength(Result,0);
    // Sistema proposto da TMS, ma non funziona mi d records in tabella 'vuoti' senza dati
    //Var JFDBS: TJSObject; JManager: TJSObject; JTableList: TJSObject; JRowList: TJSArray;
    //JFDBS := TJSObject(TJSObject(TJSJson.Parse(JsonString))['FDBS']);
    //JManager := TJSObject(JFDBS['Manager']);
    //JTableList := TJSObject(TJSArray(JManager['TableList'])[0]);
    //JRowList := TJSArray(JTableList['RowList']);
    // xData.SetJSonData(JRowList);

    JsonMain:=TJSonObject.Create();
    JsonValues:=JsonMain.ParseJSONValue(JsonString);  // Non usare Uppercase, d errore di parsing !
    JsonValues:=(JsonValues As TJSONObject).Get('FDBS').JSONValue;
    //WebMemo1.Text:=(vJSONScenario as TJSONObject).Get('Version').JSONValue.Value;
    JsonValues:=(JsonValues As TJSONObject).Get('Manager').JSONValue;
    //WebMemo1.Text:=(vJSONScenario as TJSONObject).Get('UpdatesRegistry').JSONValue.Value;
    JsonValues:=(JsonValues As TJSONObject).Get('TableList').JSONValue;
    // Prendo il rowlist della tabella nr 1 (idx = 0)
    JsonValues:=TJSONObject((JsonValues As TJSONArray).Items[0]).Get('RowList').JSONValue;

    If xData <> Nil Then Begin
      // NB : Il xData.close in certi casi d un errore di Undefined Data initrecord....
      If xData.Active Then Begin // svuoto tutto e ricarico
        While Not xData.IsEmpty() Do
          xData.Delete();
      End Else
        xData.Open();
    End;

    For i:=0 To (JsonValues As TJSONArray).Count-1 Do Begin
      JsonRecs:=TJSONObject((JsonValues As TJSONArray).Items[i]).GetValue('Original');

      If JsonRecs <> Nil Then Begin
        If xData <> Nil Then Begin
          xData.Insert();

          For j:=0 To xData.FieldCount-1 Do Begin
            CurrFld:=UpperCase(xData.Fields[j].FieldName);
            //Console.Log(CurrFld);
            If TJSONObject(JsonRecs).GetValue(CurrFld) <> Nil Then Begin
              // Console.Log(CurrFld + ' val '+TJSONObject(JsonRecs).GetValue(CurrFld).Value);
              If xData.Fields[j].DataType In [ftString] Then
                xData.FieldByName(CurrFld).Value:=
                  TJSONObject(JsonRecs).GetValue(CurrFld).Value
              Else If xData.Fields[j].DataType In [ftInteger] Then
                xData.FieldByName(CurrFld).Value:=
                  StrToInt(TJSONObject(JsonRecs).GetValue(CurrFld).Value)
              Else If xData.Fields[j].DataType In [ftFloat] Then
                xData.FieldByName(CurrFld).Value:=
                  StrToFloat(TJSONObject(JsonRecs).GetValue(CurrFld).Value)
              Else If xData.Fields[j].DataType = ftDateTime Then
                xData.FieldByName(CurrFld).Value:=
                  JSONDateTime_To_Datetime(TJSONObject(JsonRecs).GetValue(CurrFld).Value);
            End;
          End;
          xData.Post();
        End Else Begin
          For j:=0 To Length(FldNames)-1 Do Begin
            CurrFld:=FldNames[j];

            If TJSONObject(JsonRecs).GetValue(CurrFld) <> Nil Then Begin
              SetLength(Result,Length(Result)+1);
              Result[Length(Result)-1]:=TJSONObject(JsonRecs).GetValue(CurrFld).Value;
            End;
          End;
        End;
      End;
    End;
  Except
    On E:Exception Do
      Raise E.Create('GetJsonValues error : '+E.Message+' Field : '+CurrFld);
  End;
  Finally
    JsonMain.Free();
  End;
End;
// -----------------------------------------------------------------------------
procedure TDM0.WebDataModuleDestroy(Sender: TObject);
begin
  wdTOrd.Close();
  wdROrd.Close();
end;

end.
